/****************************************************************************
** Form implementation generated from reading ui file 'dlgdelete.ui'
**
** Created: Don Dez 20 21:19:08 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "dlgdelete.h"

#include <qvariant.h>   // first for gcc 2.7.2
#include <qheader.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>


/* 
 *  Constructs a dlgDelete which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
dlgDelete::dlgDelete(kcView *from, bool sym , QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	  setName( "dlgDelete" );
    resize( 305, 397 ); 
    setCaption( trUtf8( "KCommander::Delete" ) );
    dlgDeleteLayout = new QVBoxLayout( this, 11, 6, "dlgDeleteLayout"); 

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setFrameShape( QLabel::StyledPanel );
    TextLabel1->setFrameShadow( QLabel::Sunken );
    TextLabel1->setText( trUtf8( "Really delete the following files ?" ) );
    dlgDeleteLayout->addWidget( TextLabel1 );

    FileListView = new QListView( this, "FileListView" );
    FileListView->addColumn( trUtf8( "Selected dirs and files" ) );
    FileListView->addColumn( trUtf8( "Deletable" ) );
    FileListView->setColumnWidthMode ( 0, QListView::Manual);
    FileListView->setColumnWidth(0,195);

    FileListView->setFrameShadow( QListView::Sunken );
    FileListView->setAllColumnsShowFocus(true);
    FileListView->setSelectionMode(QListView::NoSelection);
    FileListView->header()->setMaximumHeight(25);
    dlgDeleteLayout->addWidget( FileListView );

    Layout1 = new QHBoxLayout( 0, 0, 6, "Layout1"); 

    TextLabel2 = new QLabel( this, "TextLabel2" );
    TextLabel2->setFrameShape( QLabel::StyledPanel );
    TextLabel2->setFrameShadow( QLabel::Sunken );
    dlgDeleteLayout->addWidget( TextLabel2 );

    OkButton = new QPushButton( this, "OkButton" );
    OkButton->setText( trUtf8( "Ok" ) );
    OkButton->setMaximumSize(3600,25);
    Layout1->addWidget( OkButton );

    CancelButton = new QPushButton( this, "CancelButton" );
    CancelButton->setText( trUtf8( "Cancel" ) );
    CancelButton->setMaximumSize(3600,25);
    Layout1->addWidget( CancelButton );
    dlgDeleteLayout->addLayout( Layout1 );

    // signals and slots connections
    connect( OkButton, SIGNAL( clicked() ), this, SLOT( startDelete() ) );
    connect( CancelButton, SIGNAL( clicked() ), this, SLOT( reject() ) );

    source = from;
    deleteSymlinks = sym;
    getRecursiveList();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
dlgDelete::~dlgDelete()
{
    // no need to delete child widgets, Qt does it all for us
}

void dlgDelete::addItem(int type,QString fileName, QString deletable )
{
    QListViewItem * item = new QListViewItem( FileListView, 0 );
    item->setText( 0, fileName);
    item->setText( 1, deletable);
    if(type == 1 )item->setPixmap(0,*source->fip->getIcon(fileName));
    else  item->setPixmap(0,*source->fip->getIcon("folder"));
}

void dlgDelete::getRecursiveList()
{
  // Diese Funktion geht alle ausgewhlten Items durch, und erstellt
  // eine QStrList mit Dirs/Files
  liste = new QStrList;
  files = dirs = bytes = 0;
  QString directory = source->dirname();

  if(dynamic_cast<kcListView*>(source))
  {
    QListViewItemIterator it((kcListView*)source);
    kcListViewItem *ki;
    for ( ; it.current(); ++it )
    {
        ki = (kcListViewItem *)it.current();
        if ( ki->isSelected() )
          if(ki->isDir()){
            if(ki->isReadable()) //muss natuerlich auch mindestens lesbar sein hat Rene vergessen !!
            {
                addItem(0,ki->text(0),"Yes");
                recurse(directory + ki->text(0) + "/");
            }
//            else
//            {   addItem(0,ki->text(0),"No");}
          }
          else
            {
              files++;
              QFileInfo fi(directory + ki->text(0));
              if(! fi.isSymLink()) bytes += fi.size();
              liste->append(directory + ki->text(0));
              addItem(1,ki->text(0),"Yes");
            }
    }
    if(liste->count() == 0)
    {
      //kein rechts-selected !!
      ki = (kcListViewItem *)((kcListView*)source)->currentItem();
      if(ki->isDir()){
        if(ki->isReadable())
        {
          addItem(0,ki->text(0),"Yes");
          recurse(directory + ki->text(0) );
        }
//        else
//            {   addItem(0,ki->text(0),"No");}
      }
      else
      {
        files++;
        QFileInfo fi(directory + ki->text(0));
        if(! fi.isSymLink()) bytes += fi.size();
        liste->append(directory + ki->text(0));
        addItem(1,ki->text(0),"Yes");
        }
    }
  }   // end if kcListView
  else
  {
    QIconViewItem *it = ((kcIconView*)source)->firstItem();
    kcIconViewItem * ki;
    do
    {
        ki = (kcIconViewItem *)it;
        if ( ki->isSelected() )
          if(ki->isDir()){
            if(ki->isReadable()) //muss natuerlich auch mindestens lesbar sein hat Rene vergessen !!
            {
                addItem(0,ki->text(),"Yes");
                recurse(directory + ki->text());
            }
//            else
//            {   addItem(0,ki->text(),"No");}
          }
          else
            {
              files++;
              QFileInfo fi(directory + ki->text());
              if(! fi.isSymLink()) bytes += fi.size();
              liste->append(directory + ki->text());
              addItem(1,ki->text(),"Yes");
            }
          it = it->nextItem();
    }
    while(it);

    if(liste->count() == 0)
    {
      //kein rechts-selected !!
      ki = (kcIconViewItem *)((kcIconView*)source)->currentItem();
      if(ki->isDir()){
        if(ki->isReadable())
        {
          addItem(0,ki->text(),"Yes");
          recurse(directory + ki->text() );
        }
//        else
//            {   addItem(0,ki->text(),"No");}
      }
      else
      {
        files++;
        QFileInfo fi(directory + ki->text());
        if(! fi.isSymLink()) bytes += fi.size();
        liste->append(directory + ki->text());
        addItem(1,ki->text(),"Yes");
        }
    }
  } // end if kcIconView

  QString count;
  count.sprintf("%u Bytes in %d/%d Files/Dirs", bytes, files, dirs);
  TextLabel2->setText( count );
}

void dlgDelete::recurse(QString dirname)
{
  dirs++;
  qApp->processEvents();
  QDir d(dirname);
  liste->append(dirname);

  if(! deleteSymlinks){
  QFileInfo inf(dirname);
  if(inf.isSymLink()) return;
  }

  d.setFilter( QDir::Files | QDir::Dirs | QDir::Hidden);
  const QFileInfoList *list = d.entryInfoList();
  QFileInfoListIterator it( *list );
  QFileInfo *fi;
  while ( (fi = it.current()) != 0 )
  {
    if(fi->fileName() != ".." && fi->fileName() != ".")
      if(fi->isReadable())
      {
       if(!deleteSymlinks) // Wenn Symbolic links nicht geloescht werden sollen
       {
        if(fi->isDir() && fi->isSymLink() == false)
        {
          recurse(dirname+ "/" + fi->fileName());
        }
        else
        {
          files++;
          if(! fi->isSymLink())bytes += fi->size();
            liste->append(dirname + "/" + fi->fileName());
        }
       }
       else // Wenn symbolic links doch geloescht werden sollen
       {
        if(fi->isDir())
        {
          recurse(dirname+ "/" + fi->fileName());
        }
        else
        {
          files++;
          if(! fi->isSymLink())bytes += fi->size();
            liste->append(dirname + "/" + fi->fileName());
        }
       }
      }
    ++it;
  }
}

void dlgDelete::startDelete()
{
  if(liste->count() == 0 ) reject();

  unsigned int i = liste->count();

  while( i > 0)  // alles rueckwaerts beim Loeschen !!
  {
    --i;
    QString fileToRemove(liste->take(i));
//    debug(fileToRemove);
    if( ! QFile(fileToRemove).remove())
      QDir(fileToRemove).rmdir(fileToRemove);
  }

  source->reRead();
  accept();
}
