/****************************************************************************
** Form interface generated from reading ui file '/home/cfricke/kcommander3view.ui'
**
** Created: Die Dez 11 17:50:48 2001
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef KCOMMANDER3VIEW_H
#define KCOMMANDER3VIEW_H

#include <qvariant.h>
#include <qwidget.h>
#include <qcombobox.h>
#include <qiconview.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qsplitter.h>
#include <qtoolbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qapplication.h>
#include <qmotifstyle.h>
#include <qstylefactory.h>
#include <qbuttongroup.h>

#include "kcsimplebutton.h"
#include "kcfiledialog.h"
#include "kcimageviewer.h"
#include "kctextviewer.h"
#include "kctextedit.h"
#include "kcdrivebuttonbar.h"
#include "bookmarkcombobox.h"
#include "inputbox.h"
#include "dlgdelete.h"
#include "dlgcopy.h"
#include "kccommandparse.h"
#include "kcedit.h"
#include "kccommon.h"
//#include "kcftpapplet.h"

/**
  *@author Christian Fricke & Ren Mrten
  */

class kcommander3view : public QWidget
{ 
    Q_OBJECT

public:
    kcommander3view( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~kcommander3view();

//    QLabel          *PlatzhalterFTP;
//    kcFTPApplet          *PlatzhalterFTP;
    QSplitter       *Splitter1;
    kcFileDialog    *ListDialog1,
                    *ListDialog2;
    QLabel          *CommandLabel;
    bookmarkComboBox* CommandBox;
    kcSimpleButton  *ToolButton1,
                    *ToolButton2,
                    *ToolButton3,
                    *ToolButton4,
                    *ToolButton5,
                    *ToolButton6,
                    *ToolButton7;
    kcDriveButtonBar* buttonBar;

    kcFileDialog    *getLeftDialog(){return ListDialog1;};
    kcFileDialog    *getRightDialog(){return ListDialog2;};
    kcFileDialog    *getActiveDialog()
                        {return activeListDialog;};    // Liefert NULL wenn neu gestartet wurde !
    QString         getCurrentDirectoryName();
    QString         getCurrentItemName();
    void              changeLists();

    /** If the user had changed the settings, using optionsdialog, we have to react to.
    * Function is called by kcommander3.cpp
    */
    void              settingsChanged();

    kcTextViewer    *tv1;
    kcTextEdit        *te1;
    kcEdit              *editor;

//public slots:
    void            setSplitterSizes();
    void            saveSplitterSizes();
    void            slotToggleView();
protected:
    QVBoxLayout     *kcommander3viewLayout;
    QHBoxLayout     *Layout2,
                    *Layout5,
                    *Layout7;
    QGridLayout *gridViewLayout;

//     QMainWindow *Parent;
private:
    void            makeConnections();
    kcFileDialog    *activeListDialog;
    kcFileDialog    *passiveListDialog;
    kcCommandParse *parseCommand;

private slots:
    void            slot_view();
    void            slot_view(int);

    void            slot_edit();
    void            slot_edit(int);

    void            slot_copy();
    void            slot_move();
    void            slot_mkdir();
    void            slot_delete();
    void            slot_delete_symlinks(int);
    void            slot_quit();
    void            activateListDialog1();
    void            activateListDialog2();
    void            activateCommandBox(QString);
    void            commandBoxReady();
    void            doCommand(const QString &);
    void            dirChanged(QString &);
    void            itemRequested();
    void            sendKeyToLV(QKeyEvent *);
    void            unselectItem(const char *, const char*);
    void            reReadBookmarks();
};

#endif // KCOMMANDER3VIEW_H
