#ifndef KCCOMMON_H
#define KCCOMMON_H
/***************************************************************************
                          kccommon.h  -  description
                             -------------------
    begin                : Wed Dec 12 2001
    copyright            : (C) 2001 by Christian Fricke & Ren Mrten
    email                : cfricke@kcommander.org
 ***************************************************************************/

// StructEntry for a fileinfo from kcDirOperator
#include <qstring.h>
#include <qdatetime.h>
#include <qregexp.h>
#include <qurl.h>

/**
  *@author Christian Fricke & Ren Mrten
  */


typedef struct {
                  QString     _directoryname;
                  QString     _fileName;
                  int         _permissions; // "rwxr-xr-x"
                  QDateTime   _lastModified;
                  QString     _owner;
                  QString     _group;
                  bool        _isSymLink;
                  bool        _isFile;
                  bool        _isDir;
                  bool        _isReadable;
                  uint        _fileSize;
                } struct_fileinfo;

#endif
